<template>
  <el-col :span="16" :offset="6">
    <el-form label-width="100px" ref="formRef" :model="form">
      <el-form-item
        label="审批建议"
        prop="reason"
        style="margin-bottom: 20px"
        :rules="{
          required: true,
          message: '请选择',
          trigger: 'change'
        }"
      >
        <el-input
          type="textarea"
          v-model="form.reason"
          placeholder="请输入审批建议"
        />
      </el-form-item>
    </el-form>
    <div style="margin-left: 10%; margin-bottom: 20px; font-size: 14px">
      <el-button
        icon="el-icon-edit-outline"
        type="success"
        size="mini"
        :loading="isSaveLoading"
        @click="storeManagerApprove"
        v-if="
          ['storeman'].includes(taskDefinitionKey) && activeComp == 'storage'
        "
        >申请入库
      </el-button>
    </div>
  </el-col>
</template>

<script>
  import { approveTaskWithVariablesOther } from '@/api/bpm/task';
  import outin from '@/api/warehouseManagement/outin';
  export default {
    name: '',
    props: {
      businessId: {
        default: ''
      },
      taskId: {
        default: ''
      },
      id: {
        default: ''
      },
      taskDefinitionKey: {
        default: ''
      }
    },
    data() {
      return {
        isSaveLoading: false,
        form: {
          reason: ''
        },
        activeComp: ''
      };
    },
    mounted() {
      console.log('taskDefinitionKey-------------', this.taskDefinitionKey);
    },
    methods: {
      async storeManagerApprove() {
        let res = await this.getTableValue();
        let storageData = res.returnStorageData;
        // 入库来源storageSource 0-正常  1-外部(外部跳过内部审核流程)
        storageData.storageSource = 1;
        console.log(storageData);
        try {
          this.isSaveLoading = true;
          let res = await outin.save(storageData);
          approveTaskWithVariablesOther({
            id: this.taskId,
            reason: this.form.reason,
            outInId: res.data[0],
            businessId: this.businessId,
            variables: {
              pass: true
            }
          }).then((res) => {
            if (res.code != '-1') {
              this.$emit('handleAudit', {
                status: 1,
                title: '入库'
              });
            }
            this.isSaveLoading = false;
          });
        } catch (error) {
          this.isSaveLoading = false;
          this.$message.error('保存失败');
        }
      },
      /** 处理转办审批人 */
      handleUpdateAssignee() {
        this.$emit('handleUpdateAssignee');
      },
      /** 退回 */
      handleBackList() {
        this.$emit('handleBackList');
      },
      activeCompChange(activeComp) {
        this.activeComp = activeComp;
      },
      getTableValue() {
        return new Promise((resolve, reject) => {
          this.$emit('getTableValue', async (data) => {
            resolve(await data);
          });
        });
      }
    }
  };
</script>

<style lang="scss"></style>
